import { Node } from 'broccoli-node-api';
import Plugin from 'broccoli-plugin';
import type Package from './package';
export declare type TreeType = 'app' | 'addon' | 'addon-templates' | 'addon-test-support' | 'styles' | 'templates' | 'test';
interface BaseImport {
    path: string;
    package: Package;
    isDynamic: boolean;
    treeType: TreeType | undefined;
}
export interface LiteralImport extends BaseImport {
    specifier: string;
}
export interface TemplateImport extends BaseImport {
    cookedQuasis: string[];
    expressionNameHints: (string | undefined)[];
}
export declare type Import = LiteralImport | TemplateImport;
export default class Analyzer extends Plugin {
    private pack;
    private treeType?;
    private previousTree;
    private modules;
    private paths;
    private parse;
    constructor(inputTree: Node, pack: Package, treeType?: TreeType | undefined);
    setupParser(): Promise<void>;
    get imports(): Import[];
    build(): Promise<void>;
    private getPatchset;
    private matchesExtension;
    removeImports(relativePath: string): void;
    updateImports(relativePath: string, source: string): void;
    private processImportCallExpression;
    private parseImports;
}
export {};
