import { AppInstance } from '@embroider/shared-internals';
import type { TreeType } from './analyzer';
export declare type BundleName = 'app' | 'tests';
export declare type BundleType = 'js' | 'css';
export default class BundleConfig {
    private emberApp;
    constructor(emberApp: AppInstance);
    get names(): ReadonlyArray<BundleName>;
    assertValidBundleName(name: string): asserts name is BundleName;
    get types(): ReadonlyArray<BundleType>;
    bundleEntrypoint(name: BundleName, type: BundleType): string;
    bundleForTreeType(treeType: TreeType): BundleName;
    bundleForPath(path: string): BundleName;
    get lazyChunkPath(): string;
    htmlEntrypoints(): any[];
}
